<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Lifinity Dungeon: cpp_filrouge_iscj_allemann/include/Log/Log.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Lifinity Dungeon
   &#160;<span id="projectnumber">6</span>
   </div>
   <div id="projectbrief">The Lifinity Dungeon is a dungeon with an infinity of room. After each room, you found a harder room. This is why you will pass the eternity of your life in this dungeon</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7b4dd9274471389300495e9c763ca813.html">cpp_filrouge_iscj_allemann</a></li><li class="navelem"><a class="el" href="dir_e5b3fe71963387781ba01d2a56ee1874.html">include</a></li><li class="navelem"><a class="el" href="dir_20252c59fe8f028a76784af50d193d74.html">Log</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Log.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_log_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_log_8hpp.html">./Log.hpp</a>&quot;</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">namespace </span>He_Arc::RPG</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;{</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_log.html">   35</a></span>&#160;    <span class="keyword">class </span><a class="code" href="class_he___arc_1_1_r_p_g_1_1_log.html">Log</a></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_log.html#af6f3e7e7e87082d7cfabf3e1c0682fe6">   41</a></span>&#160;        <span class="keyword">enum</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_log.html#af6f3e7e7e87082d7cfabf3e1c0682fe6">LogLevel</a></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;            Default,</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            Debug,</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;            <a class="code" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a>,</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;            Critical,</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        };</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_log.html#ad4e64f61acdc3f3923ed6bcc66fb7147">   53</a></span>&#160;        map&lt;LogLevel, string&gt; LogLevelToString = {</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;            {Default, <span class="stringliteral">&quot;Default&quot;</span>},</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            {Debug, <span class="stringliteral">&quot;Debug&quot;</span>},</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            {<a class="code" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a>, <span class="stringliteral">&quot;Game&quot;</span>},</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            {Critical, <span class="stringliteral">&quot;Critical&quot;</span>}</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        };</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_log.html#aa56c017981fc107fbc22eb4dabcf4d80">   63</a></span>&#160;        <span class="keyword">enum</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_log.html#aa56c017981fc107fbc22eb4dabcf4d80">LogType</a></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        {</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;            MenuAction,</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;            Character,</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;            Move,</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;            Fight,</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            <a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html">Dice</a>,</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;            File,</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;            <a class="code" href="class_he___arc_1_1_r_p_g_1_1_room.html">Room</a>,</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            Skill,</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            Other,</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        };</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div>
<div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_log.html#a527455ddbfcf4565835a697b5debc443">   80</a></span>&#160;        map&lt;LogType, string&gt; LogTypeToString = {</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;            {MenuAction, <span class="stringliteral">&quot;Menu Action&quot;</span>},</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            {Character, <span class="stringliteral">&quot;Character&quot;</span>},</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;            {Move, <span class="stringliteral">&quot;Movement&quot;</span>},</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;            {Fight, <span class="stringliteral">&quot;Fighting&quot;</span>},</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;            {<a class="code" href="class_he___arc_1_1_r_p_g_1_1_dice.html">Dice</a>, <span class="stringliteral">&quot;Dice&quot;</span>},</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;            {File, <span class="stringliteral">&quot;File&quot;</span>},</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;            {<a class="code" href="class_he___arc_1_1_r_p_g_1_1_room.html">Room</a>, <span class="stringliteral">&quot;Room&quot;</span>},</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            {Other, <span class="stringliteral">&quot;Other&quot;</span>},</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        };</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00096"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_log.html#a0452f2fff71750632decff16693c559d">   96</a></span>&#160;        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_log.html#af6f3e7e7e87082d7cfabf3e1c0682fe6">LogLevel</a> m_logLevel{LogLevel::Default};</div>
<div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_log.html#acb7fe3984bf2e515ef8707b8cc9ebce1">  101</a></span>&#160;        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_log.html#aa56c017981fc107fbc22eb4dabcf4d80">LogType</a> m_logType{LogType::Other};</div>
<div class="line"><a name="l00106"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_log.html#a21b9d683ca5b528a08a7af22fa882f1a">  106</a></span>&#160;        chrono::system_clock::time_point m_time{chrono::system_clock::now()};</div>
<div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_log.html#a901492958fd6f506275abe197a3c28ff">  111</a></span>&#160;        <span class="keywordtype">string</span> m_message{<span class="stringliteral">&quot;&quot;</span>};</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_log.html">Log</a>(LogLevel level, LogType type, <span class="keywordtype">string</span> message);</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keyword">virtual</span> ~<a class="code" href="class_he___arc_1_1_r_p_g_1_1_log.html">Log</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160; </div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        LogLevel GetLogLevel() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        LogType GetLogType() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        chrono::system_clock::time_point GetLogTime() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="keywordtype">string</span> GetLogMessage() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="keywordtype">string</span> ToString();</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    };</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;} <span class="comment">// namespace He_Arc::RPG</span></div>
<div class="ttc" id="a_log_8hpp_html"><div class="ttname"><a href="_log_8hpp.html">Log.hpp</a></div><div class="ttdoc">: Header file, for the class &quot;Log.cpp&quot;</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_dice_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_dice.html">He_Arc::RPG::Dice</a></div><div class="ttdoc">Class for the dice, gives you a random value depending the type of dice.</div><div class="ttdef"><b>Definition:</b> Dice.hpp:46</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_game_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_game.html">He_Arc::RPG::Game</a></div><div class="ttdoc">This class is the game logic implementation, It regroups each classes and interconnect them to perfor...</div><div class="ttdef"><b>Definition:</b> Game.hpp:42</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_log_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_log.html">He_Arc::RPG::Log</a></div><div class="ttdoc">This class is an entry of logs, an entry is caracterised by the level of the log; the type; and the m...</div><div class="ttdef"><b>Definition:</b> Log.hpp:36</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_log_html_aa56c017981fc107fbc22eb4dabcf4d80"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_log.html#aa56c017981fc107fbc22eb4dabcf4d80">He_Arc::RPG::Log::LogType</a></div><div class="ttdeci">LogType</div><div class="ttdoc">The type of the log (what have did the log)</div><div class="ttdef"><b>Definition:</b> Log.hpp:64</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_log_html_af6f3e7e7e87082d7cfabf3e1c0682fe6"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_log.html#af6f3e7e7e87082d7cfabf3e1c0682fe6">He_Arc::RPG::Log::LogLevel</a></div><div class="ttdeci">LogLevel</div><div class="ttdoc">The level of the log (is used when)</div><div class="ttdef"><b>Definition:</b> Log.hpp:42</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_room_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_room.html">He_Arc::RPG::Room</a></div><div class="ttdoc">The room is where the characters can do a fight. It contains lanes, and handle the laning (move chara...</div><div class="ttdef"><b>Definition:</b> Room.hpp:39</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
